progname=exercise_07_31
CC=g++
CFLAGS=-Wall -Wextra -Werror -g3

all: test1 test2

debug/$(progname): debug/$(progname).o
	$(CC) $(CFLAGS)  $<  -o  $@

debug/%.o: debug/%.s
	$(CC) -c $(CFLAGS) $<  -o $@

debug/%.s: debug/%.ii
	$(CC) -S $(CFLAGS) $<  -o $@

debug/%.ii: %.cpp | debug
	$(CC) -E  $(CFLAGS)  $<  -o $@

debug:
	mkdir -p debug

clean:
	rm -r debug Tests/*.out 

test%: debug/$(progname) 
	@./debug/$(progname) < Tests/$@.in > Tests/$@.out 2>&1 || echo "$@ is executing..."
	@diff Tests/$@.out Tests/$@.expected && echo PASSED || echo FAILED

.PRECIOUS: debug/%.ii  debug/%.s
.SECONDARY: debug/%.ii  debug/%.s

